# frozen_string_literal: true

#--
# wwwjdic
# © 2014-2021 Marco Bresciani
#
# This file is part of wwwjdic.
#
# wwwjdic is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# wwwjdic is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with wwwjdic. If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-FileCopyrightText: 2014-2021 Marco Bresciani
#
# SPDX-License-Identifier: GPL-3.0-or-later
#++

require 'simplecov'
SimpleCov.start

require 'i18n'
require 'json'
require 'minitest/autorun'
require 'minitest/spec'
require 'set'

require_relative '../lib/wwwjdic'
require_relative '../lib/wwwjdic/constants'
require_relative '../lib/wwwjdic/parsers/dict'
require_relative '../lib/wwwjdic/parsers/display'
require_relative '../lib/wwwjdic/parsers/key'
require_relative '../lib/wwwjdic/parsers/server'
require_relative '../lib/wwwjdic/utils/downloader'

require_relative 'wwwjdic/test_parsable_duck_type'

module WWWJDic
  # Example basic URI (profile part) for testing purposes.
  TEST_REFERENCE_URI = URI_DEFAULT + DICTIONARY_CODES[0] + DISPLAY[:regular]
end
