# frozen_string_literal: true

#--
# wwwjdic
# © 2014-2021 Marco Bresciani
#
# This file is part of wwwjdic.
#
# wwwjdic is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# wwwjdic is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with wwwjdic. If not, see <http://www.gnu.org/licenses/>.
#
# SPDX-FileCopyrightText: 2014-2021 Marco Bresciani
#
# SPDX-License-Identifier: GPL-3.0-or-later
#++

require_relative '../../test_helper'

describe WWWJDic::Utils::Downloader do
  describe 'when passed a nil uri' do
    it 'must raise a RuntimeError' do
      assert_raises RuntimeError do
        I18n.enforce_available_locales = false
        WWWJDic::Utils::Downloader::Downloader.download_file nil, 'filename'
      end
    end
  end

  describe 'when passed an invalid uri' do
    it 'must raise a InvalidURIError' do
      assert_raises URI::InvalidURIError do
        I18n.enforce_available_locales = false
        WWWJDic::Utils::Downloader::Downloader.download_file 'http://example.com/%uABCD', 'filename'
      end
    end
  end
end
